# 用户操作日志对接文档
## 说明
目前整个mis平台的日志系统，没有将前后端的日志串联起来，基于全链路追踪日志的设计，需要设计出一款适用于整个平台的日志系统。
## 日志形成及流向
+ 用户的交互操作(如按钮点击),会由组件库(或插件)生成统一的唯一key(时间戳+账号信息)；
+ 组件库(或插件)将该key + 用户交互信息发送到日志服务, 写入数据库；
+ 因该次操作所产生的业务请求,也会携带key, 发送到业务服务;
+ 标准库中的拦截器将key + 业务服务的正常/异常响应,通过MQ发送到日志服务,日志服务消费之后，通过key形成用户操作到服务响应的闭环

## 前端对接

### 安装依赖
``` bash
1. 设置npm源
npm config set registry http://39.106.145.141:9000/repository/node-public/
2. 安装
npm install wb_notebook-test1 -S
```
### 指令使用 项目入口文件 main.js
``` bash
// 操作收集指令
import collect from 'web_notebook-test1';
Vue.use(collect);
```
### axios替换
将axios替换为web_notebook-test1模块的Request, 该Request为[web标准库](https://git.allhome.com.cn/NetWorksDatas/Public/standard/blob/master/%E5%8D%83%E5%AE%B6Web%E6%A0%87%E5%87%86%E5%BA%93%E4%BD%BF%E7%94%A8%E8%AF%B4%E6%98%8E%E6%96%87%E6%A1%A3.md)中封装的
#### 由easy-mock-cli生成的的api, 修改instance.js; 
``` bash
import config from '../config';
import { Request } from 'web_notebook-test1';
const baseURL = {
  mock: 'http://mock.allhome.com.cn/mock/5db2630933901100102f2e2f/javaLog',
  development : 'http://192.168.10.12:8991',
  lan: `http://192.168.10.200:8009/projectName`,
  pred: `https://dtgateway.allhome.com.cn/projectName`,
  production: `https://gateway.allhome.com.cn/projectName`
}['development'];

const request = new Request({
  baseURL,
  timeout: 60000,
}, 'development', 'yourWebAppName');

const devToken = 'tokenString';
const token = window.token? window.token: (window.token = devToken);

// 设置拦截器
request.interceptors({
    request: config => {
      config.headers.token = token;
      return config
    },
    response: res => {
      let {message, result, statusCode} = res.data
      //  退出登录状态码
      let logoutCodes = new Set([435001, 435011, 436050])
      if (statusCode === 1000) {
        //  更新全局token
        let {pragma} = res.headers
        if (pragma) window.token = pragma
        //  返回数据
        return result
      } else if (logoutCodes.has(statusCode)) {
        setTimeout(() => window.logout(), 1000)
        return Promise.reject({message})
      } else {
        return Promise.reject({message,statusCode})
      }
    },
    error: error =>  Promise.reject(error.response.data),
  })
export default request.axios;

```
#### 未使用easy-mock-cli的项目可直接直接参考[web标准库](https://git.allhome.com.cn/NetWorksDatas/Public/standard/blob/master/%E5%8D%83%E5%AE%B6Web%E6%A0%87%E5%87%86%E5%BA%93%E4%BD%BF%E7%94%A8%E8%AF%B4%E6%98%8E%E6%96%87%E6%A1%A3.md)替换