
/**
 * @date 2019.10.25
 * @author 潘亚楠
 * @information 拦截器配置
 */
import createDebug from 'debug'
import bus from './bus';
// token
const devToken = 'L2bhC0FyEWXo9zkt6mQ15lMzsSgS3dR/V+w5iWSiMmG0H0t1pL9lr4o+nSKXhjOm9qT+UrXqbLUpiWmITwS1q6TPmZvSumEkoEzpYFr0ylbxHafk+uE8yvK9OWiYl9WEH/JdnMw2LVnVYur7LOe/r57MMxw4e/NxGKPo07pqgn8=';
const token = window.token? window.token: (window.token = devToken);
const debug = createDebug('test-拦截器');

export default {
    request: config => {
      config.headers.token = token;
      debug(config.headers);
      const { interaction_timestamp: interactionTimestamp } = config.headers;
      bus.$emit('request', { token, interactionTimestamp });
      return config
    },
    response: res => {
      let {message, result, statusCode} = res.data
      //  退出登录状态码
      let logoutCodes = new Set([435001, 435011, 436050])
      if (statusCode === 1000) {
        //  更新全局token
        let {pragma} = res.headers
        if (pragma) window.token = pragma
        //  返回数据
        return result
      } else if (logoutCodes.has(statusCode)) {
        setTimeout(() => window.logout(), 1000)
        return Promise.reject({message})
      } else {
        return Promise.reject({message,statusCode})
      }
    },
    error: error =>  Promise.reject(error.response.data),
  } 